/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model.impl;

import java.util.Arrays;

import org.eclipse.core.resources.IResourceDelta;

import model.IHElement;
import model.IHElementDelta;
import model.IHElementDeltaMirror;

/**
 * TODO JavaDoc
 */
public abstract class HElementDeltaBase
    implements IHElementDelta, IHElementDeltaImpl
{
    private IResourceDelta[] resourceDeltas;

    @Override
    public IHElement hElement()
    {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public int hKind()
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public long hFlags()
    {
        // TODO Auto-generated method stub
        return 0;
    }

    @Override
    public IHElementDelta[] hAffectedChildren()
    {
        return IHElementDelta.EMPTY_ARRAY;
    }

    @Override
    public IResourceDelta[] hResourceDeltas()
    {
        return resourceDeltas;
    }

    @Override
    public void hAddResourceDelta(IResourceDelta resourceDelta)
    {
        if (resourceDelta == null)
            throw new IllegalArgumentException();
        if (resourceDeltas == null)
        {
            resourceDeltas = new IResourceDelta[1];
            resourceDeltas[0] = resourceDelta;
        }
        else
        {
            int newLength = resourceDeltas.length + 1;
            resourceDeltas = Arrays.copyOf(resourceDeltas, newLength);
            resourceDeltas[newLength - 1] = resourceDelta;
        }
    }

    @Override
    public IHElementDeltaMirror hMirror()
    {
        if (this instanceof IHElementDeltaMirror)
            return (IHElementDeltaMirror)this;
        else
            return new IHElementDeltaMirror()
            {
                @Override
                public IHElementDelta hDelta()
                {
                    return HElementDeltaBase.this;
                }
            };
    }
}
