/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model.test2;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.core.runtime.CoreException;

import model.IHElement;
import model.impl.IHElementImpl;

/**
 * TODO JavaDoc
 */
public interface IFooElement
    extends IHElement
{
    default String getElementName()
    {
        return ((IHElementImpl)this).hName();
    }

    default IFooElement getParent()
    {
        return (IFooElement)((IHElementImpl)this).hParent();
    }

    default List<IFooElement> getChildren() throws CoreException
    {
        List<?> backingList = Arrays.asList(
            ((IHElementImpl)this).hChildren());
        @SuppressWarnings("unchecked")
        List<IFooElement> result =
            (List<IFooElement>)Collections.unmodifiableList(backingList);
        return result;
    }
}
