/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model.test2;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import model.IHElementDelta;
import model.IHElementDeltaMirror;
import model.impl.IHElementDeltaImpl;

/**
 * TODO JavaDoc
 */
public interface IFooElementDelta
    extends IHElementDelta
{
    int ADDED = IHElementDeltaMirror.ADDED;
    int REMOVED = IHElementDeltaMirror.REMOVED;
    int CHANGED = IHElementDeltaMirror.CHANGED;

    long F_CONTENT = IHElementDeltaMirror.F_CONTENT;
    long F_CHILDREN = IHElementDeltaMirror.F_CHILDREN;

    default public IFooElement getElement()
    {
        return (IFooElement)((IHElementDeltaImpl)this).hElement();
    }

    default int getDeltaKind()
    {
        return ((IHElementDeltaImpl)this).hKind();
    }

    default long getChangeFlags()
    {
        return ((IHElementDeltaImpl)this).hFlags();
    }

    default List<IFooElementDelta> getAffectedChildren()
    {
        List<?> backingList = Arrays.asList(
            ((IHElementDeltaImpl)this).hAffectedChildren());
        @SuppressWarnings("unchecked")
        List<IFooElementDelta> result =
            (List<IFooElementDelta>)Collections.unmodifiableList(backingList);
        return result;
    }
}
