/*******************************************************************************
 * Copyright (c) 2016 1C-Soft LLC.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Vladimir Piskarev (1C) - initial API and implementation
 *******************************************************************************/
package model.test3;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import model.IHElementDeltaMirror;
import model.impl.IHElementDeltaImpl;

/**
 * TODO JavaDoc
 */
public interface IFooElementDelta
{
    int CHANGED = 1;
    int ADDED = 2;
    int REMOVED = 3;

    int F_CHILDREN = 0x1;
    int F_CONTENT = 0x2;

    default IFooElement getElement()
    {
        return (IFooElement)((IHElementDeltaImpl)this).hElement();
    }

    default int getKind()
    {
        int hKind = ((IHElementDeltaImpl)this).hKind();
        if (hKind == 0)
            return 0;
        if (hKind == IHElementDeltaMirror.ADDED)
            return ADDED;
        if (hKind == IHElementDeltaMirror.REMOVED)
            return REMOVED;
        if (hKind == IHElementDeltaMirror.CHANGED)
            return CHANGED;
        throw new AssertionError();
    }

    default int getFlags()
    {
        int result = 0;
        long hFlags = ((IHElementDeltaImpl)this).hFlags();
        if ((hFlags & IHElementDeltaMirror.F_CONTENT) != 0)
            result |= F_CONTENT;
        if ((hFlags & IHElementDeltaMirror.F_CHILDREN) != 0)
            result |= F_CHILDREN;
        return result;
    }

    default List<IFooElementDelta> getAffectedChildren()
    {
        List<?> backingList = Arrays.asList(
            ((IHElementDeltaImpl)this).hAffectedChildren());
        @SuppressWarnings("unchecked")
        List<IFooElementDelta> result =
            (List<IFooElementDelta>)Collections.unmodifiableList(backingList);
        return result;
    }
}
